program MondbewegungundPhasen;                                             (* 5.5.2003 *)

uses
  Forms,
  WinTypes, SysUtils,
  Graphics,
  FensterGraf in 'c:\sources.del\FensterGraf.pas' {Grundfenster},
  Eingabe in 'c:\sources.del\EINGABE.PAS' {EingabeDialog},
  KernGraf in 'c:\sources.del\KernGraf.pas',
  Kern2Graf in 'c:\sources.del\Kern2Graf.pas',
  ModulGraf in 'c:\sources.del\ModulGraf.pas',
  ErdmodulDelphi in 'c:\sources.del\ErdmodulDelphi.pas',
  mathe in 'c:\sources.del\mathe.pas',
  AstrRout in 'c:\sources.del\Astrrout.pas',
  Planets1 in 'c:\sources.del\PLANETS1.PAS',
  Moon in 'c:\sources.del\MOON.PAS';

{$R *.RES}

(*const xm = 1023; ym = 767;*)

const Titel = 'RahmenGraf';
      Version = '1.2';
      VersionsDatum = '8.3.2008';
      inBitmap = true;
      Infotext = false;
      Startbild = false;
      Fontname = 'Courier';
      Fontsize = 10;
      Fontstyle = 0;
      Infodatei = 'MondbewegungundPhasen.txt';
      Bildname = 'MondbewegungundPhasen';

const Schiefe = 23.5*Grad;                            (* Schiefe der Ekliptik *)
      aMond = 60.0;                           (* groe Halbachse der Mondbahn *)
      exMond = 0.0549;

                                              (* Konstanten fr "Mondphasen": *)
      rSph = 1.0;                                 (* Radius der Himmelssphre *)

type Horizontalmodus = (kein, rotErde, rotHimmel);
     Darstellungsart = (Phase, Bewegung);

var Darstellung: Darstellungsart;

var Taste, BildNr, Verzoegerung: integer;
    loesche, Abbruch, Pause, Einzelschritt, init, Hilfegezeigt,
    WerteEingelesen: boolean;

    Tag, Daemmerung, nautDaemmerung: boolean;
    Ekliptik, Aequator: boolean; EkliptikC, AequatorC: Char;
    Linienabstand: real; LinienabstandStr: String;
    rMond, rSonne: rVektor;                         (* geoz. ekl. Koordinaten *)
    pMond, pSonne: pVektor;
    Datum: Zeitpunkt;
    Mez, jd, theta, djd, cosSchiefe, sinSchiefe, sinBreite, cosBreite,
    phi, lambda, xDrehwinkel: real;
    rE, xE, yE, sign, rM: integer;
    DE, D, DT, Di, Dx, Dy, D_x, D_y, Dtheta, D_theta, Dphi, D_phi: Matrix;
    DatumStr, UhrzeitStr, OrtStr,
    djdStr, VerzoegerungStr, TagStr, MonatStr, JahrStr, MezStr,
    phiStr, lambdaStr: String;
    hm: Horizontalmodus;
    Ort: Punkt;                                             (* Bezugsstandort *)
    tx: Text;

                                               (* Variablen fr "Mondphasen": *)
    r0: rVektor = (0.0, -1.05*rSph, 0.0, 0.35*rSph); (* Zentralpunkt der Projektion *)
    Azimut00, Azimut0, xMax, PhasePh, LimbusPh: real;
    Azimut0Str, BreiteStr, Zeitstring: String;
    zMin, xB, yB, x0, y0, rMondPh, HFarbe: integer;
    D0: Matrix;
    pS, pM: rVektor;
    lS, bS, rS, lM, bM, rMPh, xSonne, zSonne, xMond, zMond: real;
    inf: boolean;

procedure initGrafik;                (* wenn in Bitmap gezeichnet werden soll *)

   begin
   zCanvas:=Grundfenster.GrafikBMP.Canvas;
   zCanvas.Font:=Grundfenster.Canvas.Font;
   end;

procedure Information;

   var tx: Text;
       s: String;
       y, n, f, t, b: integer;

   begin
   if not DateiVorhanden('ECLGRAPH.DAT') and not DateiVorhanden('Erde.bin') then
      begin
      waehleFont(Fontname, 20, 1);
      zeichneGrafstring(50,50, 'Das Programm bentigt zur Darstellung der Erdkugel', hellrot);
      zeichneGrafstring(50, 50+2*zHoehe, ' eine der Dateien "ECLGRAPH.DAT" oder "Erde.bin" !', hellrot);
      inf:=true; exit
      end;
   t:=Grundfenster.ClientOrigin.y+(Grundfenster.ClientHeight-Eingabedialog.Height) div 2;
   b:=t+Eingabedialog.Height;
   inf:=false;
   setzeFuelltyp(255, schwarz, schwarz);
   fuelleRechteck(0, 0, xm, ym);
   setzeTextHFarbe(schwarz);
   if not DateiVorhanden(Infodatei) then Exit;
   Filemode:=0;
   Assign(tx, Infodatei); Reset(tx);
   Filemode:=fmShareDenyWrite;
   waehleFont(Fontname, Fontsize+4, 1);
   y:=2*zHoehe; n:=0; f:=gelb;
   while not eof(tx) do
      begin
      if (y>t-2*zHoehe) and
         (y<b+2*zHoehe) then
                                (* Der Eingabedialog muss ausgelassen werden. *)
         begin
         repeat
            zeichneGrafstring(0, y, '', weiss); Inc(y, zHoehe)
         until y>b+2*zHoehe;
         end;
      if n=3 then
         begin
         waehleFont(Fontname, Fontsize, 0); f:=weiss
         end;
      ReadLn(tx, s); zeichneGrafstring(0, y, s, f); Inc(y, zHoehe); Inc(n);
      end;
   inf:=true;
   end;

procedure holeEinstellungen;

   var tx: Text;
       Code: integer;
       s: String;
       DarstellungC, EinzelschrittC: Char;

   begin
   Assign(tx, Paramstr(1)); Reset(tx);
   ReadLn(tx, DarstellungC);
   if DarstellungC in ['p','P']
      then Darstellung:=Phase
      else Darstellung:=Bewegung;
   ReadLn(tx, phiStr);  if Pos(' ',  phiStr)>0 then  phiStr:=Copy( phiStr, 1, Pos(' ',  phiStr)-1);
   wandleStringInReal( phiStr,  phi, Code); if Code>0 then Halt;
   ReadLn(tx, lambdaStr);  if Pos(' ',  lambdaStr)>0 then  lambdaStr:=Copy( lambdaStr, 1, Pos(' ',  lambdaStr)-1);
   wandleStringInReal(lambdaStr,  lambda, Code); if Code>0 then Halt;
   ReadLn(tx, s);
   TagStr:=Copy(s, 1, Pos('.', s)-1); Delete(s, 1, Pos('.', s));
   MonatStr:=Copy(s, 1, Pos('.', s)-1); Delete(s, 1, Pos('.', s));
   JahrStr:=Copy(s, 1, 4);
   wandleStringInInteger( TagStr,  Datum.Tag, Code); if Code>0 then Halt;
   wandleStringInInteger( MonatStr,  Datum.Monat, Code); if Code>0 then Halt;
   wandleStringInInteger( JahrStr,  Datum.Jahr, Code); if Code>0 then Halt;
   ReadLn(tx, MezStr);  if Pos(' ',  MezStr)>0 then  MezStr:=Copy( MezStr, 1, Pos(' ',  MezStr)-1);
   wandleStringInReal( MezStr,  Mez, Code); if Code>0 then Halt;
   ReadLn(tx, djdStr);  if Pos(' ',  djdStr)>0 then  djdStr:=Copy( djdStr, 1, Pos(' ',  djdStr)-1);
   wandleStringInReal( djdStr,  djd, Code); if Code>0 then Halt;
   ReadLn(tx, VerzoegerungStr);  if Pos(' ',  VerzoegerungStr)>0 then  VerzoegerungStr:=Copy( VerzoegerungStr, 1, Pos(' ',  VerzoegerungStr)-1);
   wandleStringInInteger( VerzoegerungStr,  Verzoegerung, Code); if Code>0 then Halt;
   ReadLn(tx, Azimut0Str);
   if Pos(' ',  Azimut0Str)>0 then  Azimut0Str:=Copy( Azimut0Str, 1, Pos(' ',  Azimut0Str)-1);
   wandleStringInReal( Azimut0Str,  Azimut0, Code); if Code>0 then Halt;
   ReadLn(tx, LinienabstandStr);
   if Pos(' ',  LinienabstandStr)>0 then  LinienabstandStr:=Copy(LinienabstandStr, 1, Pos(' ',  LinienabstandStr)-1);
   wandleStringInReal( LinienabstandStr,  Linienabstand, Code); if Code>0 then Halt;
   Linienabstand:=Linienabstand*Grad;
   ReadLn(tx, AequatorC);
   Aequator:=AequatorC in ['j','J'];
   ReadLn(tx, EkliptikC);
   Ekliptik:=EkliptikC in ['j','J'];
   ReadLn(tx, EinzelschrittC);
   Einzelschritt:=EinzelschrittC in ['j','J'];
   Close(tx);
   end;

procedure speichereEinstellungen;

   var tx: Text;

   begin
   Assign(tx, 'MondbewegungundPhasen.dat'); Rewrite(tx);
   if Darstellung=Phase then System.Write(tx, 'p') else System.Write(tx, 'b');
   System.Writeln(tx, ' * Darstellung (Phase (p)/Bewegung)');
   System.Writeln(tx, phiStr+' * geogr. Breite');
   System.Writeln(tx, lambdaStr+' * geogr. Lnge');
   System.Writeln(tx, TagStr+'.'+MonatStr+'.'+JahrStr+ ' * Startdatum');
   System.Writeln(tx, MezStr+' * Startuhrzeit');
   System.Writeln(tx, djdStr+' * deltat');
   System.Writeln(tx, VerzoegerungStr+' * Verzgerung in ms');
   System.Writeln(tx, Azimut0Str+' * zentraler Azimut');
   System.Writeln(tx, LinienabstandStr+' * Abstand der Koordinatenlinien');
   System.Writeln(tx, AequatorC+' * Zeichnung der quators (j/n)?');
   System.Writeln(tx, EkliptikC+' * Zeichnung der Ekliptik (j/n)?');
   System.Writeln(tx, 'j * Einzelschritt (j/n)?');
   close(tx);
   end;

procedure Beschriftung;

   var st, sm, sj, sMez, s: String;
       y: integer;

   begin
   setzeFuelltyp(255, schwarz, schwarz);
   fuelleRechteck(ym, 0, xm, ym);
   wandleZahlInString(  Datum.Tag, 2.0, st); if st[1]=' ' then Delete(st, 1, 1);
   wandleZahlInString(Datum.Monat, 2.0, sm); if sm[1]=' ' then Delete(sm, 1, 1);
   wandleZahlInString( Datum.Jahr, 4.0, sj); if sj[1]=' ' then Delete(sj, 1, 1);
   wandleZahlInString(Mez, 2.2, sMez); if sMez[1]=' ' then Delete(sMez, 1, 1);
   if Pos('.60', sMez)>0 then
      begin
      wandleZahlInString(Round(Mez), 2.2, sMez);
      if sMez[1]=' ' then Delete(sMez, 1, 1);
      end;
   UhrzeitStr:=sMez;
   DatumStr:=st+'.'+sm+'.'+sj+'  ';
   waehleFont('Courier', 20, 1);
   setzeTextausrichtung(0, 0);
   y:=2*zHoehe;
   zeichneGrafstring(ym+10, y, DatumStr, weiss); Inc(y, zHoehe);
   zeichneGrafstring(ym+10, y, sMez+' Uhr MEZ', weiss); Inc(y, zHoehe);
   waehleFont('Courier', 10, 0);
   setzeTextausrichtung(0, 0);
   s:='Standort: '+phiStr+GradC;
   if phi>=0.0 then s:=s+' n.B., '+lambdaStr+GradC else s:=s+' s.B., '+lambdaStr+GradC;;
   if lambda>=0.0 then s:=s+' .L.' else s:=s+' w.L.';
   while Pos('-', s)>0 do Delete(s, Pos('-', s), 1);
   OrtStr:=s;
   zeichneGrafstring(ym+10, y, OrtStr, weiss);
   waehleFont('Courier', 16, 1);
   if hm<>rotHimmel
      then zeichneGrafstring(ym, 200-zHoehe, ' ekl. System:', weiss)
      else zeichneGrafstring(ym, 200-zHoehe, ' hor. System:', weiss);
   waehleFont('Courier', 10, 0);
   setzeTextausrichtung(2,0);
   zeichneGrafstring(xm, ym-5, 'F1: Hilfe ', hellrot);
   setzeTextausrichtung(0,0);
(*   if Einzelschritt
      then zeichneGrafstring(ym-50, ym-5, ' weiter mit Tastendruck ! ', grau)
      else zeichneGrafstring(ym-50, ym-5, '                          ', grau);*)
   setzeTextausrichtung(0, 0);
   case hm of
      kein: begin
            setzeTextausrichtung(2,0);
            zeichneGrafstring(ym, yE-rE, 'Horizont', schwarz);
            setzeTextausrichtung(2,2);
            zeichneGrafstring(ym, yE-rE, 'Osten', schwarz);
(*            zeichneLinie(ym, yE, ym+50, yE, gelb);*)
            setzeTextausrichtung(0,1);
            zeichneGrafstring(ym, yE, ' zum Frhlingspunkt ------->', gelb);
            setzeTextausrichtung(0,0);
            if abs(xDrehwinkel)<1.0*Grad
               then zeichneGrafstring(ym+zBreite, 200, 'Blick vom Nordpol der Ekliptik', weiss)
               else begin
                    wandleZahlInString(90-abs(xDrehwinkel/Grad), 2.0, s);
                    zeichneGrafstring(ym+zBreite, 200, 'Blick von '+s+GradC+' nrdl. ekl. Breite', weiss)
                    end;
            end;
      rotErde: begin
               if phi>=0.0
                  then wandleZahlInString(abs((23.5*Grad+phi)/Grad), 2.1, s);
               zeichneGrafstring(ym+zBreite, 200, 'Blick von '+s+GradC+' nrdl. ekl. Breite', weiss);
               zeichneLinie(ym, yE, ym+50, yE, gelb);
               setzeTextausrichtung(0,1);
               zeichneGrafstring(ym+60, yE, 'zum Frhlingspunkt', gelb);
               end;
      rotHimmel: begin
                 setzeTextausrichtung(2,0);
                 zeichneGrafstring(ym, yE-rE, 'Horizont', hellgrau);
                 setzeTextausrichtung(2,2);
                 zeichneGrafstring(ym, yE-rE, 'Osten', hellgrau);
                 if phi>=0.0 then s:='Sden' else s:='Norden';
                 setzeTextausrichtung(0, 0);
                 zeichneGrafstring(ym+10, 200+0*zHoehe, 'Blick ber den Standort                    ', weiss);
                 zeichneGrafstring(ym+10, 200+1*zHoehe, 'Richtung '+s, weiss);
                 end;
      end;
   setzeTextausrichtung(2,0);
   zeichneGrafstring(xm, ym-5, 'F1: Hilfe ', hellrot);
   setzeTextausrichtung(0,0);
(*   if Einzelschritt
      then zeichneGrafstring(ym-50, ym-5, ' weiter mit Tastendruck ! ', grau)
      else zeichneGrafstring(ym-50, ym-5, '                          ', grau);*)
   end;

procedure berechneSonneundMond;

   var pl: pVektor;
       rl: rVektor;

   begin
   gregDatum(jd, Datum, Mez);
   theta:=Sternzeit(Datum, Mez, lambda);
   if hm<>rotHimmel
      then
         begin
         definiereYDrehung(-theta+lambda(*+Pi*), Dtheta); (* "+Pi", um die x-Achse nach links zu drehen *)
         definiereYDrehung(theta-lambda(*-Pi*), D_theta);
         end
      else if phi>=0.0                  (* verstehe ich auch noch nicht ganz! *)
              then
                  begin
                  definiereYDrehung(-0+lambda-HPi, Dtheta);
                  definiereYDrehung( 0-lambda+HPi, D_theta);
                  end
              else
                 begin
                 definiereYDrehung(-0+lambda+HPi, Dtheta);
                 definiereYDrehung( 0-lambda-HPi, D_theta);
                 end;
   with pSonne do Sun200(julJahrhunderte(jd), Laenge, Breite, r);
   pSonne.r:=pSonne.r*AE;
(*   if hm in [kein,rotErde] then with pSonne do Laenge:=Laenge+Pi;*)
   Mathe.berechneCartK(pSonne, rSonne);
   if hm=rotHimmel then
      begin
      EclEqu(sinSchiefe, cosSchiefe, rSonne[2], rSonne[3]);
      Mathe.berechnePolarK(rSonne, pl);
      AeKoord2HoKoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
      Mathe.berechneCartK(pl, rl);
      if phi>=0.0
         then definiereRVektor( rl[2], rl[3], rl[1], rSonne)
         else definiereRVektor(-rl[2], rl[3], -rl[1], rSonne);
      end;

   with pMond do Moon200(julJahrhunderte(jd), Laenge, Breite, r);
(*   if hm in [kein,rotErde] then with pMond do Laenge:=Laenge+Pi;*)
   Mathe.berechneCartK(pMond, rMond);
   if hm=rotHimmel then
      begin
      EclEqu(sinSchiefe, cosSchiefe, rMond[2], rMond[3]);
      Mathe.berechnePolarK(rMond, pl);
      AeKoord2HoKoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
      Mathe.berechneCartK(pl, rl);
      multipliziereRVektor(0.9*aMond/rl[0], rl);
      definiereRVektor(rl[1], rl[3], rl[2], rMond);
      if phi>=0.0
         then definiereRVektor( rl[2], rl[3], rl[1], rMond)
         else definiereRVektor(-rl[2], rl[3], -rl[1], rMond);
      end;
   Beschriftung;
   end;

procedure Rotation(var p, pn: Punkt); far;

   var pl: Punkt;

   begin
   pl:=p;
   pl.r[0]:=p.r[0];
   pl.r[1]:=p.r[1];
   pl.r[2]:=-p.r[3];
   pl.r[3]:=p.r[2];
   ErdModulDelphi.dreheRVektor(Dtheta, pl.r);   (* evtl. zusammenfassen! *)
   ErdModulDelphi.dreheRVektor(Di, pl.r);
   ErdModulDelphi.dreheRVektor(DT, pl.r);
   ErdModulDelphi.berechnePolarK(pl.r, pl.p);
   pn:=pl;
   end;

function inBild(var p: Punkt): boolean; far;

   begin
   inBild:=(p.r[2]<0.0) and (sqr(p.r[1])+sqr(p.r[3])<0.95)
   end;

procedure berechneKoordinaten(var p: Punkt; var xp, yp: integer); far;

   begin
   xp:=Round(xE+rE*p.r[1]);
   yp:=Round(yE-rE*p.r[3]);
   end;

procedure Initialisierung;

   var h, min, s: integer;

   begin
   rM:=25;                                      (* Pixelradius des Mondes *)
   rE:=4*rM;
   sinSchiefe:=sin(Schiefe); cosSchiefe:=cos(Schiefe);
   setzeVGAPalette;
   init:=true;
(*initGrafik;*)
   definiereRVektor(r0[1], r0[2], r0[3], r0);           (* Projektionszentrum *)
   BildNr:=0;
   pKoordinaten:=berechneKoordinaten;
   fInBild:=inBild;
   Abbildung:=Rotation;
{   definiereXDrehung( 23.5*Grad, Di); (* mit x-Achse nach rechts msste das Vorz.Taste entgegengesetzt sein! *)}
   definiereXDrehung(-23.5*Grad, Di); (* mit x-Achse nach rechts msste das Vorz.Taste entgegengesetzt sein! *)
   definiereXDrehung(0.0, DE);
   if ParamCount>0 then
      begin
      holeEinstellungen; Exit
      end;
   with Datum do
      begin
      holeDatum(Tag, Monat, Jahr);
      wandleZahlInString(Tag, 2.0, TagStr);
      wandleZahlInString(Monat, 2.0, MonatStr);
      wandleZahlInString(Jahr, 4.0, JahrStr)
      end;
   holeUhrzeit(h, min, s, s);
   wandleZahlInString(h+0.01*min, 2.2, MezStr);
   phiStr:='50'; lambdaStr:='7';
   if Darstellung=Bewegung then djdStr:='1' else djdStr:='0.05';
   if Darstellung=Bewegung then VerzoegerungStr:='100' else VerzoegerungStr:='30';
   LinienabstandStr:='30';
   AequatorC:='n'; EkliptikC:='n';
   Azimut0Str:='0';
   WerteEingelesen:=false;
   Information;
   Darstellung:=Phase;
   Azimut00:=1000.0;
   end;

procedure Ausgabe; forward;

procedure zeichneMondphase(rv: rVektor; x0, y0, r, f, hf: integer);
(* Die Routine ist fr den Fall geschrieben worden, dass die x-Achse nach rechts
zeigt, die y-Achse nach hinten! *)

   var Phase, Limbus: real;
       rp: rVektor;

   begin
   if Darstellung=Bewegung then
      begin
      if hm<>rotHimmel then dreheRVektor(D, rv);
      r:=r-1;                            (* sonst klappt das Lschen nicht ganz! *)
      setzeFuelltyp(255, hf, hf);
      fuelleEllipse(x0, y0, r, r);
      definiereRVektor(rv[1], rv[3], rv[2], rv); (* wegen der ungew. Achsenorientierung *)
      end;
   normiereRVektor(rv);
   definiereRVektor(rv[1], 0.0, rv[3], rp);
   Limbus:=atn2(rp[3], rp[1])/Grad;
   Phase:=atn2(rv[2], rp[0]);
   zeichneHEllipse(x0, y0, r, r, 255, f, false, true, -90.0+Limbus);
   if Phase>0
      then zeichneHEllipse(x0, y0, r, Round(r*sin( Phase)), 255,      hf, false, true, -90.0+Limbus)
      else zeichneHEllipse(x0, y0, r, Round(r*sin(-Phase)), 255,       f, false, true,  90.0+Limbus);
   end;

procedure zeichneMond (f: integer);

   var rl: rVektor;
       xp, yp: integer;

   begin
   if (hm=rotHimmel) and (rMond[2]<0.0) then Exit; (* Mond unter dem Horizont? *)
   rl:=rMond;
   if hm<>rotHimmel then dreheRVektor(D, rl);
   xp:=xPlot(rl[1]); yp:=yPlot(rl[2]);
   if hm=rotHimmel then Dec(yp, rE);
   setzeFuelltyp(255, f, f);
   if f=schwarz
      then fuelleEllipse(xp, yp, rM, rM)
      else zeichneMondphase(rSonne, xp, yp, rM, hellgrau, grau);
   end;

var xpl, ypl: integer;

procedure zeichneErde(f: integer);

   var pl: Punkt;
       xp, yp, rB, ld: integer;

   begin
   if rE>4.5*rM then rB:=5 else rB:=7;
   if rE>4.5*rM then ld:=2 else ld:=1;
   setzeFuelltyp(255, schwarz, schwarz);
   fuelleEllipse(xpl, ypl, rB, rB);                   (* Lschen des Standortes *)
   if f=schwarz
      then fuelleEllipse(xE, yE, rE+10, rE+10)
      else zeichneMondphase(rSonne, xE, yE, rE, hellblau, grau);
   zeichnesErde(Rotation, berechneKoordinaten, inBild,
                weiss, ld, weiss,
                false, true, false,
                30.0, schwarz, hellrot);
   Rotation(Ort, pl);                              (* Zeichnen des Standortes *)
   if (pl.r[2]<0.0) or (hm=rotHimmel) then
      begin
      berechneKoordinaten(pl, xp, yp);
      setzeFuelltyp(255, hellrot, hellrot);
      fuelleEllipse(xp, yp, rB, rB);
      xpl:=xp; ypl:=yp;
      end;
   end;

var xpSl, ypSl: integer;

procedure zeichneSonne(f: integer);

   var xp, yp: integer;

   begin
   setzeFuelltyp(255, schwarz, schwarz);
   fuelleEllipse(xpSl, ypSl, rM, rM);
   if (rSonne[2]<0.0) or (f=schwarz) then Exit;
   setzeFuelltyp(255, f, f);
   xp:=xPlot(rSonne[1]/rSonne[0]*aMond); yp:=yPlot(rSonne[2]/rSonne[0]*aMond)-rE;
   fuelleEllipse(xp, yp, rM, rM);
   xpSl:=xP; ypSl:=yp;
   end;

(**************************** Prozeduren aus "Mondphasen" *********************)

procedure AbbildungPh(r0, r: rVektor; var y, z: real; var def: boolean);
             (* Zentralprojektion von r0 auf Tangentialebene bei az=0 und h=0 *)

   var lambda: real;
       rl: rVektor;

   begin
   dreheRVektor(D0, r);         (* Drehung des zentralen Azimuts in die Mitte *)
   subtrahiereRVektoren(r, r0, rl);
   if r[1]=r0[1] then
      begin
      def:=false; Exit
      end;
   lambda:=(rSph-r0[1])/(r[1]-r0[1]);
   y:=r0[2]+lambda*(r[2]-r0[2]);
   z:=r0[3]+lambda*(r[3]-r0[3]);
   def:=Skalarprodukt(r, rl)>0.0;                 (* vorderer Teil der Kugel? *)
   end;

procedure berechneSonneundMondPh;

   var pl: pVektor;
       kr, lv, r1, r2: rVektor;
       x1, z1, x2, z2: real;
       def: boolean;

   begin
   gregDatum(jd, Datum, Mez);
   theta:=Sternzeit(Datum, Mez, lambda);
   Sun200(julJahrhunderte(jd), lS, bS, rS);
   with pl do
      begin
      Laenge:=lS; Breite:=bS; r:=rSph
      end;
   Mathe.berechneCartK(pl, pS);
   EclEqu(sinSchiefe, cosSchiefe, pS[2], pS[3]);
   Mathe.berechnePolarK(pS, pl);            (* quatoriale Position der Sonne *)
   AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
   Tag:=pl.Breite>0.0;
       Daemmerung:=(pl.Breite<  0.0*Grad) and (pl.Breite>- 6.0*Grad);
   nautDaemmerung:=(pl.Breite<-6.0*Grad);
   if Tag
      then HFarbe:=hellblau
           else if Daemmerung
                   then HFarbe:=blau
                   else HFarbe:=schwarz;
   Mathe.berechneCartK(pl, pS);           (* pS: Pos. der Sonne an der Sphre *)
   AbbildungPh(r0, pS, xSonne, zSonne, def);

   Moon200(julJahrhunderte(jd), lM, bM, rMPh);
   with pl do
      begin
      Laenge:=lM; Breite:=bM; r:=rSph
      end;
   Mathe.berechneCartK(pl, pM);
   EclEqu(sinSchiefe, cosSchiefe, pM[2], pM[3]);
   Mathe.berechnePolarK(pM, pl);           (* quatoriale Position des Mondes *)
   AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
   Mathe.berechneCartK(pl, pM);          (* pM: Pos. des Mondes an der Sphre *)
   AbbildungPh(r0, pM, xMond, zMond, def);

   berechneKreuzprodukt(pS, pM, kr);
   normiereRVektor(kr);   (* kr: Normvektor auf der Ebene Sonne - Erde - Mond *)
   berechneKreuzprodukt(pM, kr, lv);
   normiereRVektor(lv);      (* lv: Richtung vom Mond zur Sonne an der Sphre *)
   multipliziereRVektor(25*Grad*rSph, lv);
   addiereRVektoren(pM, lv, lv);
   AbbildungPh(r0, pM, x1, z1, def);
   AbbildungPh(r0, lv, x2, z2, def);
   LimbusPh:=atn2(-yPlot(z2)+yPlot(z1), xPlot(x2)-xPlot(x1));
   with pl do
      begin
      Laenge:=lS; Breite:=bS; r:=rS
      end;
   Mathe.berechneCartK(pl, r1); (* rechtw. ekl. Koordinaten der Sonne im Raum *)
   with pl do
      begin
      Laenge:=lM; Breite:=bM; r:=rM/AE
      end;
   Mathe.berechneCartK(pl, r2); (* rechtw. ekl. Koordinaten des Mondes im Raum*)
   berechneKreuzprodukt(r1, r2, kr);
   subtrahiereRVektoren(r2, r1, r1);                 (* Vektor Mond --> Sonne *)
   normiereRVektor(r1); normiereRVektor(r2);
   PhasePh:=arccos(Skalarprodukt(r1, r2));
   if kr[3]<0.0                                     (* Sonne rechts vom Mond? *)
      then PhasePh:=-PhasePh;
   end;

procedure zeichneHorizont(f: integer);

   var y, z: real;
       rl: rVektor;
       pl: pVektor;
       def: boolean;

   begin
   with pl do
      begin
      Laenge:=0.0; Breite:=0.0; r:=rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, y, z, def);
   geheNach(xPlot(-y), yPlot(z));
   while pl.Laenge<ZweiPi do
      begin
      pl.Laenge:=pl.Laenge+2.0*Grad;
      Mathe.berechneCartK(pl, rl);
      AbbildungPh(r0, rl, y, z, def);
      if not def
         then geheNach(xPlot(-y), yPlot(z))
         else zieheLinieNach(xPlot(-y), yPlot(z), f);
      end;
   end;

procedure zeichneAzimutlinie(az: real; f: integer);

   var y, z: real;
       rl: rVektor;
       pl: pVektor;
       def: boolean;

   begin
   with pl do
      begin
      Laenge:=az; Breite:=HPi; r:=rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, y, z, def);
   geheNach(xPlot(y), yPlot(z));
   while pl.Breite>0.0 do
      begin
      pl.Breite:=pl.Breite-2.0*Grad;
      Mathe.berechneCartK(pl, rl);
      AbbildungPh(r0, rl, y, z, def);
      if not def
         then geheNach(xPlot(y), yPlot(z))
         else zieheLinieNach(xPlot(y), yPlot(z), f);
      end;
   end;

procedure zeichneHoehenlinie(h: real; f: integer);

   var y, z: real;
       rl: rVektor;
       pl: pVektor;
       def: boolean;

   begin
   with pl do
      begin
      Laenge:=-180.0*Grad; Breite:=h; r:=rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, y, z, def);
   geheNach(xPlot(y), yPlot(z));
   while pl.Laenge<180.0*Grad do
      begin
      pl.Laenge:=pl.Laenge+2.0*Grad;
      Mathe.berechneCartK(pl, rl);
      AbbildungPh(r0, rl, y, z, def);
      if not def
         then geheNach(xPlot(y), yPlot(z))
         else zieheLinieNach(xPlot(y), yPlot(z), f);
      end;
   end;

procedure zeichneRektaszensionslinie(alpha: real; f: integer);

   var y, z, Breite: real;
       rl: rVektor;
       pl: pVektor;
       def: boolean;

   begin
   Breite:=85.0*Grad;
   pl.Laenge:=alpha; pl.Breite:=Breite; pl.r:=rSph;
   AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, y, z, def);
   geheNach(xPlot(y), yPlot(z));
   while (Breite>-85.0*Grad) and (pl.Breite>0.0) do
      begin
      Breite:=Breite-2.0*Grad;
      pl.Breite:=Breite; pl.Laenge:=alpha;
      AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
      Mathe.berechneCartK(pl, rl);
      AbbildungPh(r0, rl, y, z, def);
      if not def or (pl.Breite<0.0)
         then geheNach(xPlot(y), yPlot(z))
         else zieheLinieNach(xPlot(y), yPlot(z), f);
      end;
   end;

procedure zeichneDeklinationslinie(delta: real; f: integer);

   var y, z, Laenge: real;
       rl: rVektor;
       pl: pVektor;
       def: boolean;

   begin
   Laenge:=-180.0*Grad;
   pl.Laenge:=Laenge; pl.Breite:=delta; pl.r:=rSph;
   AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, y, z, def);
   geheNach(xPlot(y), yPlot(z));
   while Laenge<180.0*Grad do
      begin
      Laenge:=Laenge+2.0*Grad;
      pl.Laenge:=Laenge; pl.Breite:=delta;
      AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
      Mathe.berechneCartK(pl, rl);
      AbbildungPh(r0, rl, y, z, def);
      if not def or (pl.Breite<0.0)
         then geheNach(xPlot(y), yPlot(z))
         else zieheLinieNach(xPlot(y), yPlot(z), f);
      end;
   end;

procedure zeichneAequator(f: integer);

   begin
   zeichneDeklinationslinie(0.0, f);
   end;

procedure zeichneEkliptik(f: integer);

   var Laenge, y, z: real;
       rl: rVektor;
       def: boolean;
       pl: pVektor;

   begin
   Laenge:=0.0;
   pl.Laenge:=Laenge; pl.Breite:=0.0; pl.r:=rSph;
   Mathe.berechneCartK(pl, rl);
   EclEqu(sinSchiefe, cosSchiefe, rl[2], rl[3]);
   Mathe.berechnePolarK(rl, pl);
   AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, y, z, def);
   geheNach(xPlot(y), yPlot(z));
   while Laenge<ZweiPi do
      begin
      Laenge:=Laenge+2.0*Grad;
      pl.Laenge:=Laenge; pl.Breite:=0.0; pl.r:=rSph;
      Mathe.berechneCartK(pl, rl);
      EclEqu(sinSchiefe, cosSchiefe, rl[2], rl[3]);
      Mathe.berechnePolarK(rl, pl);
      AeKoord2Hokoord(sinBreite, cosBreite, theta, pl.Laenge, pl.Breite);
      Mathe.berechneCartK(pl, rl);
      AbbildungPh(r0, rl, y, z, def);
      if not def or (pl.Breite<0.0)
         then geheNach(xPlot(y), yPlot(z))
         else zieheLinieNach(xPlot(y), yPlot(z), grau);
      end;
   end;

procedure zeichneSphaere(dw: real; fBoden, fHimmel, fLinien: integer);

   var az, h, x, z: real;
       rl: rVektor;
       pl: pVektor;
       def: boolean;
str: String;

   begin
   zeichneHorizont(fLinien);
                                                       (* Horizontebene grn: *)
   definiereRVektor(phi/abs(phi)*0.5*rSph, 0.0, 0.0, rl);
   AbbildungPh(r0, rl, x, z, def);
   setzeFuelltyp(255, fBoden, fBoden);
   fuelleFlaeche(xPlot(-x), yPlot(z), fLinien);
                                                              (* Himmel blau: *)
   definiereRVektor(phi/abs(phi)*1.0*rSph, 0.0, 0.1*rSph, rl);
   AbbildungPh(r0, rl, x, z, def);
   setzeFuelltyp(255, fHimmel, fHimmel);
   fuelleFlaeche(xPlot(-x), yPlot(z), fLinien);
   az:=0.0;
   while az-dw>=-Pi do az:=az-dw;
   while az<Pi do
      begin
      zeichneAzimutlinie(az, fLinien);
      az:=az+dw
      end;
   h:=0.0;
   while h<90.0*Grad do
      begin
      zeichneHoehenlinie(h, fLinien);
      h:=h+dw
      end;
                                          (* obere Begrenzungsflche schwarz: *)
   definiereRVektor(0.0, rSph*cos(100.0*Grad), rSph*sin(100.0*Grad), rl);
   AbbildungPh(r0, rl, x, z, def);
   setzeFuelltyp(255, schwarz, schwarz);
   zMin:=yPlot(z)-50;
(*wandleZahlInString(zMin,4,str); zeichneGrafstring(100, 100, str, weiss);*)
   fuelleRechteck(0, 0, xm, zMin);
                                           (* Azimutlinien in der Ebene grau: *)
   definiereRVektor(0.0, 0.0, 0.0, rl);
   AbbildungPh(r0, rl, x, z, def);
   xB:=xPlot(x); yB:=yPlot(z);
   az:=-pi;
   while az<pi-dw do
      begin
      definiereRVektor(-rSph*sin(az), rSph*cos(az), 0.0, rl);
      AbbildungPh(r0, rl, x, z, def);
      KernGraf.zeichneLinie(xB, yB, xPlot(x), yPlot(z), grau);
      az:=az+dw
      end;

   setzeTextausrichtung(1,1);
   setzeTextHFarbe(fBoden);
   with pl do                                           (* Himmelsrichtungen: *)
      begin
      Laenge:=0.0; Breite:=0.0; r:=0.90*rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, x, z, def);
   if def then zeichneGrafstring(xPlot(x), yPlot(z), 'S', weiss);
   with pl do
      begin
      Laenge:=-HPi; Breite:=0.0; r:=0.90*rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, x, z, def);
   if def then zeichneGrafstring(xPlot(x), yPlot(z), 'O', weiss);
   with pl do
      begin
      Laenge:=HPi; Breite:=0.0; r:=0.90*rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, x, z, def);
   if def then zeichneGrafstring(xPlot(x), yPlot(z), 'W', weiss);
   with pl do
      begin
      Laenge:=Pi; Breite:=0.0; r:=0.90*rSph
      end;
   Mathe.berechneCartK(pl, rl);
   AbbildungPh(r0, rl, x, z, def);
   if def then zeichneGrafstring(xPlot(x), yPlot(z), 'N', weiss);

                                                 (* eigener Standort hellrot: *)
   setzeFuelltyp(255, hellrot, hellrot);
   fuelleEllipse(xB, yB, 2, 2);
   end;

procedure zeichneaequSphaere(dw: real; f: integer);

   var az, h: real;

   begin
   az:=0.0;
   while az-dw>-Pi do az:=az-dw;
   while az<=Pi do
      begin
      if az=0.0 then setzeLinienbreite(3) else setzeLinienbreite(1);
      zeichneRektaszensionslinie(az, f);
      az:=az+dw
      end;
   h:=0.0;
   while h-dw>-Hpi do h:=h-dw;
   while h<90.0*Grad do
      begin
      if h=0.0 then setzeLinienbreite(3) else setzeLinienbreite(1);
      zeichneDeklinationslinie(h, f);
      h:=h+dw
      end;
   setzeFuelltyp(255, schwarz, schwarz);
   fuelleRechteck(0, 0, xm, zMin);
   waehleFont(Fontname, 20, 1);
   zeichneGrafstring(x0, zMin-10, Zeitstring, weiss);
   end;

   procedure zeichneMondphaseN(Phase, Limbus: real; x0, y0, r, f, hf: integer);

   begin
   Limbus:=Limbus/Grad;
   zeichneHEllipse(x0, y0, r, r, 255, f, false, true, -90.0+Limbus);
   if Phase>0
      then zeichneHEllipse(x0, y0, r, Round(r*sin( Phase)), 255,      hf, false, true, -90.0+Limbus)
      else zeichneHEllipse(x0, y0, r, Round(r*sin(-Phase)), 255,       f, false, true,  90.0+Limbus)
   end;

procedure zeichneSonnePh(x0, y0, r, f: integer);

   begin
   setzeFuelltyp(255, f, f);
   fuelleEllipse(x0, y0, rMondPh, rMondPh)
   end;

(******************************************************************************)

procedure Vorbereitung;

   var i: integer;
       rl: rVektor;
       z: real;
       def: boolean;

   begin
   phi:=phi*Grad; lambda:=lambda*Grad;
   Azimut0:=Azimut0*Grad;
   sinBreite:=sin(phi); cosBreite:=cos(phi);
   djd:=hmin2hdez(djd)/24.0;
   setzeTextHFarbe(schwarz);
   jd:=julDatum(Datum, Mez);
   sign:=1;

         rMondPh:=15;
         x0:=xm div 2; y0:=ym div 2;
         setzeBildschirmausschnitt(0, xm, 0, ym);
         xMax:=2.5*rSph;
         dimensioniereBildschirm(-xMax, xMax, -0.5*xMax/xm*ym, 1.5*xMax/xm*ym);

         theta:=Sternzeit(Datum, Mez, lambda);
(*         Azimut0:=Azimut0*Grad;*)
         definiereZDrehung(-Azimut0, D0);
         BreiteStr:=' ('+phiStr+GradC+'n.B., '+lambdaStr+GradC+'.L.)';
         if not DateiVorhanden('tmp1.bmp') or not DateiVorhanden('tmp2.bmp') or not DateiVorhanden('tmp3.bmp')
            or (Azimut0<>Azimut00)
            then
               begin
               for i:=1 to 3 do
                  begin
                  setzeFuelltyp(255, schwarz, schwarz);
                  fuelleRechteck(0, 0, xm, ym);
                  case i of
                     1: zeichneSphaere(Linienabstand, gruen, schwarz, grau);
                     2: zeichneSphaere(Linienabstand, gruen, blau, grau);
                     3: zeichneSphaere(Linienabstand, hellgruen, hellblau, grau);
                     end;
                  setzeTextausrichtung(1,2);
                  zeichneGrafstring(xB, yB+3, 'Beobachter', weiss);
                  setzeTextausrichtung(2, 0);
                  setzeTextHFarbe(schwarz);
                  zeichneGrafstring(xm, zHoehe, '"F1": Hilfe ', hellrot);
                  speichereFBild('tmp'+Chr(48+i)+'.bmp', 0, 0, xm, ym);
                  end;
               Azimut00:=Azimut0;
               end
            else
               begin
   definiereRVektor(0.0, 0.0, 0.0, rl);
   AbbildungPh(r0, rl, x, z, def);
   xB:=xPlot(x); yB:=yPlot(z);
               end;
         setzeFuelltyp(255, schwarz, schwarz);

         with Ort do
            begin
            with p do
               begin
               Laenge:=lambda; Breite:=phi; r:=1.0
               end;
            ErdmodulDelphi.berechneCartK(p, r);
            end;
         if phi>0.0
            then
               begin
               definiereXDrehung( (-23.5*Grad+phi), Dphi);
               definiereXDrehung(-(-23.5*Grad+phi), D_phi);
               end
            else
               begin
               definiereXDrehung( (-23.5*Grad+Pi-phi), Dphi);
               definiereXDrehung(-(-23.5*Grad+Pi-phi), D_phi);
               end;
         definiereXDrehung( 10.0*Grad, Dx);
         definiereYDrehung( 10.0*Grad, Dy);
         definiereXDrehung(-10.0*Grad, D_x);
         definiereYDrehung(-10.0*Grad, D_y);
         definiereYDrehung(  0.0*Grad, D);
         definiereYDrehung(  0.0*Grad, DT);
         setzeBildschirmausschnitt(rM, ym-rM, rM, ym-rM);
         dimensioniereBildschirm(-(1.0+exMond)*aMond, (1.0+exMond)*aMond,
                                 -(1.0+exMond)*aMond, (1.0+exMond)*aMond);
         xE:=xPlot(0.0); yE:=yPlot(0.0);

   if Darstellung=Bewegung
      then
         begin
         fuelleRechteck(0, 0, xm, ym);
         if ParamCount=0 then begin
         for i:=1 to 7 do jd:=jd-3.4;
         hm:=kein;
         for i:= 1 to 7 do
            begin
            berechneSonneundMond;
            jd:=jd+3.4;
            zeichneMond(hellgrau);
            setzeTextausrichtung(1,0);
            zeichneGrafstring(xPlot(rMond[1]), yPlot(rMond[2])-rM-2*zHoehe, Datumstr, weiss);
            zeichneGrafstring(xPlot(rMond[1]), yPlot(rMond[2])-rM-1*zHoehe, Uhrzeitstr+' Uhr MEZ', weiss);
            end; end;
         berechneSonneundMond;
         zeichneErde(hellblau);
         zeichneMond(hellgrau);
         setzeTextausrichtung(1,0);
         zeichneGrafstring(xPlot(rMond[1]), yPlot(rMond[2])-rM-2*zHoehe, Datumstr, hellrot);
         zeichneGrafstring(xPlot(rMond[1]), yPlot(rMond[2])-rM-1*zHoehe, Uhrzeitstr+' Uhr MEZ', hellrot);
         loesche:=false;
         Hilfegezeigt:=false;
         xDrehwinkel:=0.0;
         Beschriftung;
         if ParamCount=0 then jd:=jd-djd;
         end
      else
         begin
         setzeBildschirmausschnitt(0, xm, 0, ym);
         dimensioniereBildschirm(-xMax, xMax, -0.5*xMax/xm*ym, 1.5*xMax/xm*ym);
         end;
(*zeichneFBild('tmp3.bmp', 0, 0);*)
   end;

procedure parEingabe; far;

   begin
   if not Grundfenster.active then Exit;
   if not init then Initialisierung;
   Fenstertitel:='  Eingabe der Parameter';
   if not inf then
      begin
      setzeFuelltyp(255, schwarz, schwarz);
      fuelleRechteck(0, 0, xm, ym);
      end;;
   setzeVGAPalette;
(*initgrafik;*)
   if (ParamCount=0) or WerteEingelesen then
      begin
      liesReal('Standort: geogr. Breite in Grad', phiStr, phi);
      liesReal('geogr. Lnge in Grad', lambdaStr, lambda);
      liesInteger('Starttag', TagStr, Datum.Tag);
      liesInteger('Monat', MonatStr, Datum.Monat);
      liesInteger('Jahr', JahrStr, Datum.Jahr);
      liesReal('Uhrzeit (MEZ)', MezStr, Mez);
      liesReal('Zeitschritt in hh.mm', djdStr, djd);
      liesInteger('Verzgerung in ms', VerzoegerungStr, Verzoegerung);
(*      if phi>=0.0
         then
            begin
            Azimut0Str:='0'; Azimut0:=0.0
            end
         else
            begin
            Azimut0Str:='180'; Azimut0:=180.0
            end;  *)
      if Darstellung=Phase then
         begin
         liesReal('zentraler Azimut in Grad', Azimut0Str, Azimut0);
         liesReal('Abstand der Koordinatenlinien in Grad', LinienabstandStr, Linienabstand);
         Linienabstand:=Linienabstand*Grad;
         liesChar('Soll der quator gezeichnet werden (j/n) ?', AequatorC);
         Aequator:=AequatorC in ['j','J'];
         liesChar('Soll die Ekliptik gezeichnet werden (j/n) ?', EkliptikC);
         Ekliptik:=EkliptikC in ['j','J'];
         end;
      Einzelschritt:=true;
      end;
   inf:=false;
   WerteEingelesen:=true;
   Vorbereitung;
   Ausgabe;
   started:=true; Abbruch:=false; Pause:=false;
   end;

var esl: boolean;

procedure Ausgabe;

   var x, z: real;
       def: boolean;
       ts, ms, js,us: String;
       f, hf: integer;
       pv: pVektor;
       rl: rVektor;

   begin
   if Hilfegezeigt then
      begin
      setzeFuelltyp(255, schwarz, schwarz);
      fuelleRechteck(0, 0, xm, ym);
      Hilfegezeigt:=false;
      Einzelschritt:=esl;                (* Wiederherstellen des Schrittmodus *)
      end;
   warte(Verzoegerung);
   if Darstellung=Bewegung then
      begin
      if loesche then zeichneMond(schwarz);
(*      jd:=jd+sign*djd;*)
{   if loesche
      then jd:=jd+djd
      else jd:=jd+3.4;                      (* ca. 8 Mondstellungen pro Monat *)}
      end;
   if Darstellung=Bewegung
      then
         begin
         berechneSonneundMond;
         if hm=rotHimmel then zeichneLinie(0, yE-rE, ym, yE-rE, grau);  (* Horizont *)
         if hm=rotHimmel then zeichneSonne(gelb);
         if rMond[2]<0.0
            then
               begin
               zeichneErde(hellblau);
               zeichneMond(hellgrau);
               end
            else
               begin
               zeichneMond(hellgrau);
               zeichneErde(hellblau);
               end;
         end
      else
         begin
      (*   rekonstruiereBildschirm; *)
         berechneSonneundMondPh;
   definiereRVektor(0.0, rSph*cos(100.0*Grad), rSph*sin(100.0*Grad), rl);
   AbbildungPh(r0, rl, x, z, def);
   setzeFuelltyp(255, schwarz, schwarz);
   zMin:=yPlot(z)-50;
         if Tag  (* Diese Zeilen mssen ausgeklammert werden, um Sein Serienbild herzustellen. *)
            then zeichneFBild('tmp3.bmp', 0, 0)
                 else if Daemmerung
                         then zeichneFBild('tmp2.bmp', 0, 0)
                         else zeichneFBild('tmp1.bmp', 0, 0);
(*zeichneFBild('MondbewegungundPhasen00.bmp', 0, zMin-50);*)
         setzeTextausrichtung(2, 0);
(*         if Einzelschritt
            then zeichneGrafstring(xm-Length('"F1": Hilfe ')*zBreite, zHoehe, 'weiter mit Tastendruck, ', grau)
            else zeichneGrafstring(xm-Length('"F1": Hilfe ')*zBreite, zHoehe, '                        ', grau);*)
         if Aequator then zeichneAequator(grau);
         if Ekliptik then zeichneEkliptik(grau);
         wandleZahlInString(Datum.Tag, 2, ts); if ts[1]=' ' then Delete(ts, 1, 1);
         wandleZahlInString(Datum.Monat, 2, ms); if ms[1]=' ' then Delete(ms, 1, 1);
         wandleZahlInString(Datum.Jahr, 4, js);
         wandleZahlInString(Mez, 2.2, us); Delete(us, 1, 1);
         if Pos('.60', us)>0 then
            begin
            wandleZahlInString(Round(Mez), 2.2, us); Delete(us, 1, 1);
            end;
         setzeSchriftgroesse(30);
         waehleFont(Fontname, 20, 1);
         setzeTextausrichtung(1,0);
         setzeTextHFarbe(schwarz);
         Zeitstring:=ts+'.'+ms+'.'+js+', '+us+' Uhr';
         zeichneGrafstring(x0, zMin-10, Zeitstring+BreiteStr, weiss);
         waehleFont(Fontname, Fontsize, Fontstyle);
         Mathe.berechnePolarK(pS, pv);
         if pv.Breite<0.0 then f:=rot else f:=hellrot;
         AbbildungPh(r0, pS, x, z, def);
         if pv.Breite>-10.0*Grad then zeichneSonnePh(xPlot(x), yPlot(z), rMondPh, f);
         Mathe.berechnePolarK(pM, pv);
         if pv.Breite<0.0 then begin f:=braun; hf:=gruen end else begin f:=gelb; hf:=blau end;
         AbbildungPh(r0, pM, x, z, def);
      (*   zeichneMondphase(rv, xPlot(x), yPlot(z), rMond, gelb, blau);*)
         if hf=blau then hf:=HFarbe;
         if pv.Breite>-10.0*Grad then zeichneMondphaseN(abs(PhasePh)-HPi, LimbusPh, xPlot(x), yPlot(z), rMondPh, f, hf);
(*         jd:=jd+sign*djd;*)
         end;
jd:=jd+sign*djd;
(*wandleZahlInString(xm,4,ts); zeichnegrafstring(100,100,ts,gelb);*)
   end;

procedure Pausenanfangprozedur;

   begin
   Pause:=true;
   end;

procedure Pausenendeprozedur;

   begin
   Pause:=false
   end;

procedure Hilfe;

   var x, y: integer;

   begin
   esl:=Einzelschritt;                             (* Merken des Schrittmodus *)
   Einzelschritt:=true;
   setzeFuelltyp(255, schwarz, schwarz);
   setzeTextausrichtung(0, 0);
   setzeTextHFarbe(schwarz);
   if Darstellung=Bewegung
      then
         begin
         x:=ym-150;y:=2*zHoehe;
         fuelleRechteck(x, 0, xm, ym);
         zeichneGrafstring(x, y, '"e": Einzelschritt an/aus', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"p": Pause an/aus', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"*","/"  : Zeitschritt grer/kleiner', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"<=","=>": Verzgerung grer/kleiner', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"^","v"  : Kippen des Bildes nach hinten/vorn', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"-","+"  : Richtung des Zeitschrittes', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '">","<"  : Mond und Sonne oder Erde grer/kleiner', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"h": Wahl der Perspektive (in Horizontmodus):', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '     1. Blick ber den Breitenkreis des Standortes,', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '     2. Blick ber Horizont bei ruhender Erde,', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '     3. Blick vom Ekliptiknordpol.        ', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"s": Bildspeicherung', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, ' F2: Abspeichern der Eingabeparameter', weiss); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, y, '"d": Wechsel zur Ansicht von innen', hellrot); Inc(y, 2*zHoehe);
         zeichneGrafstring(x, ym-5, 'weiter mit Tastendruck !', hellrot);
         end
      else
         begin
         fuelleRechteck(0, 0, xm, zMin);
         setzeSchriftgroesse(10);
         y:=zHoehe;
         zeichneGrafstring(0, y, ' weiter mit Tastendruck!', hellrot); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "e"    : Einzelschritt an/aus', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "s"    : Speichern des Bildes', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "a"    : Einblenden der quatorialkoordinaten', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "p"    : Pause an/aus', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "+"    : positive Zeitrichtung', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "-"    : nderung der Zeitrichtung', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "l"    : Visierlinien zu Sonne und Mond', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '  "*","/"  : Zeitschritt grer/kleiner            "<=","=>": Verzgerung grer/kleiner', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '  ">","<"  : Sonne und Mond grer/kleiner                F2: Abspeichern der Eingabeparameter', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '   "ESC"   : Neueingabe der Parameter ', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '  "Ctrl C" : Abbruch des Programmes', weiss); Inc(y, zHoehe);
         zeichneGrafstring(0, y, '    "d"    : Wechsel zur Ansicht von auen', hellrot);
         end;
   Hilfegezeigt:=true;
   end;

procedure Schleife; far;

   var NrStr: String;

   begin
   if not started then Start;
   if Abbruch or not started then Exit;
   if TasteGedrueckt then
      if Pause then
         begin
         Pausenendeprozedur; Taste:=Tastencode;
         end;
   if Pause or (Einzelschritt and not TasteGedrueckt) then Exit;
   Taste:=Tastencode;
   if (Darstellung=Bewegung) and (Taste<>F1) and not loesche then
      begin
      setzeFuelltyp(255, schwarz, schwarz);
      if not loesche then fuelleRechteck(0, 0, ym, ym);
      loesche:=true
      end;
   case Taste of
      Esc: if ParamCount>0 then Halt else begin
           Abbruch:=true;
           Info1Str:='Abbruch';
           Start;
           end;
      Ord('p'): Pausenanfangprozedur;
      Ord('e'): Einzelschritt:=not Einzelschritt;
      Ord('*'): djd:=2.0*djd;
      Ord('/'): djd:=0.5*djd;
(*      Ord('+'): sign:=1;
      Ord('-'): sign:=-sign;*)
      Ord('-'): begin jd:=jd-sign*djd; sign:=-sign; end;
      Ord('+'): begin jd:=jd-sign*djd; sign:=1; end;
      CursorRechts: if Verzoegerung>=2 then Verzoegerung:=Verzoegerung div 2;
      CursorLinks: Verzoegerung:=2*Verzoegerung;
      Ord('a'): if Darstellung=Phase then begin
                zeichneaequSphaere(Linienabstand, hellgrau);
                Einzelschritt:=true
                end;
      Ord('l'): if Darstellung=Phase then begin
                zeichneLinie(xB, yB, xPlot(xSonne), yPlot(zSonne), hellrot);
                zeichneLinie(xB, yB, xPlot(xMond), yPlot(zMond), gelb);
                end;
      Ord('h'): begin
                zeichneMond(schwarz);
                case hm of
                   kein: hm:=rotErde;
                   rotErde: hm:=rotHimmel;
                   rotHimmel: hm:=kein;
                   end;
                if hm=kein then
                   begin
                   zeichneSonne(schwarz);
                   zeichneLinie(0, yE-rE, ym, yE-rE, schwarz);
                   end;
                zeichneErde(schwarz);
                if hm=rotErde
                   then   (* Verdrehung so, dass Standort oberen Rand streift *)
                      begin
                      D:=Dphi; DT:=D_phi;
(*                      D:=D_phi; DT:=Dphi;*)
                      end
                   else if hm<>rotHimmel then               (* "Grundzustand" *)
                           begin
                           D:=DE; DT:=DE
                           end;
                if hm=rotHimmel then
                   zeichneLinie(0, yE-rE, ym, yE-rE, schwarz); (* Lschen des Horizontes *)
                if rMond[2]<0.0                       (* wenn Mond "vor" Erde *)
                    then
                        begin
                        zeichneErde(hellblau);
                        zeichneMond(hellgrau);
                        end
                     else
                        begin
                        zeichneMond(hellgrau);
                        zeichneErde(hellblau);
                        end;
                jd:=jd-sign*djd; (* um die in "Ausgabe" folgende, unerwnschte Zeitnderung zu kompensieren! *)
                end;
      CursorHoch: begin if Darstellung=Bewegung then begin
                  zeichneMond(schwarz);
                  zeichneErde(schwarz);
                  xDrehwinkel:=xDrehwinkel+10.0*Grad;
                  multipliziereMatrizen(Dx, D, D);
                  multipliziereMatrizen(DT, D_x, DT);
                  if rMond[2]<0.0
                     then
                        begin
                        zeichneErde(hellblau);
                        zeichneMond(hellgrau);
                        end
                     else
                        begin
                        zeichneMond(hellgrau);
                        zeichneErde(hellblau);
                        end;
                  Beschriftung;  end;
                  end;
      CursorRunter: begin if Darstellung=Bewegung then begin
                    zeichneMond(schwarz);
                    zeichneErde(schwarz);
                    xDrehwinkel:=xDrehwinkel-10.0*Grad;
                    multipliziereMatrizen(D, D_x, D);
                    multipliziereMatrizen(Dx, DT, DT);
                    if rMond[2]<0.0
                       then
                          begin
                          zeichneErde(hellblau);
                          zeichneMond(hellgrau);
                          end
                       else
                          begin
                          zeichneMond(hellgrau);
                          zeichneErde(hellblau);
                          end;
                    Beschriftung; end;
                    end;
      Ord('s'): begin
                NrStr:=Chr(48 +BildNr div 10)+Chr(48+BildNr mod 10);
                if Darstellung=Phase
                   then speichereFBild(Bildname+NrStr+'.bmp', 0, zMin-50, xm, ym)
                   else speichereFBild(Bildname+NrStr+'.bmp', 0,       0, xm, ym);
                Inc(BildNr);
                end;
      Ord('>'): begin
                if Darstellung=Phase
                   then rMondPh:=Round(1.1*rMondPh)
                   else rE:=Round(1.1*rE);
                jd:=jd-sign*djd;
                end;
      Ord('<'): begin
                if Darstellung=Phase
                   then rMondPh:=Round(0.9*rMondPh)
                   else
                      begin
                      setzeFuelltyp(255, schwarz, schwarz);
                      fuelleEllipse(xE, yE, rE+10, rE+10);
                      rE:=Round(0.9*rE);
                      end;
                jd:=jd-sign*djd;
                end;
      Ord('d'): begin
                if Darstellung=Bewegung then
                   begin
                   Darstellung:=Phase;
                   setzeBildschirmausschnitt(0, xm, 0, ym);
                   dimensioniereBildschirm(-xMax, xMax, -0.5*xMax/xm*ym, 1.5*xMax/xm*ym);
                   end
                else
                   begin
                   Darstellung:=Bewegung;
                   setzeBildschirmausschnitt(rM, ym-rM, rM, ym-rM);
                   dimensioniereBildschirm(-(1.0+exMond)*aMond, (1.0+exMond)*aMond,
                                           -(1.0+exMond)*aMond, (1.0+exMond)*aMond);
                   end;
                setzeFuelltyp(255, schwarz, schwarz);
                fuelleRechteck(0, 0, xm, ym);
jd:=jd-sign*djd;
                end;
      F1: Hilfe;
      F2: speichereEinstellungen;
      end;
   if not (Taste in [Esc, F1, CursorHoch, CursorRunter, Ord('a'), Ord('l'), Ord('s')]) then Ausgabe;
   setzeTextausrichtung(0, 0);
   setzeTextHFarbe(-1);
   zeichneGrafstring(0, ym-5, ' weiter mit Tastendruck ("Esc: neue Eingabe, "F1": Hilfe, "Strg-C": Abbruch des Programms)', hellrot);
   end;


begin (* Hauptprogramm *)
init:=false;
Application.CreateForm(TGrundfenster, Grundfenster);
  Application.CreateForm(TEingabeDialog, EingabeDialog);
  initProgram(inBitmap, Infotext, Startbild, Fontname, Fontsize, Fontstyle);

start:=parEingabe;
run:=Schleife;

Application.Run;                                (* Start der Programmschleife *)
end.
